'**************************************************************************
'*                       MSSetup Yellow Pages Setup
'**************************************************************************

'$DEFINE DEBUG  ''Define for script development/debugging

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc'

CONST SW_SHOWMAXIMIZED = 3
DECLARE FUNCTION ShowWindow LIB "user" (hWnd%, nCmdShow%) AS INTEGER

''Dialog ID's
CONST WELCOME       = 100
CONST EXITSUCCESS   = 200
CONST DESTPATH      = 300
CONST ASKQUIT       = 500
CONST BADPATH       = 1400
CONST EXITFAILURE   = 2100
CONST EXITQUIT      = 2200
CONST APPHELP       = 2600
CONST BILL1         = 5000
CONST BILL2         = 5010
CONST BILL3         = 5020


''Bitmap ID
CONST LOGO = 1


GLOBAL DEST$        ''Default destination directory.


DECLARE SUB Install
DECLARE FUNCTION MakePath (szDir$, szFile$) AS STRING

INIT:
    CUIDLL$ = "mscuistf.dll"            ''Custom user interface dll
    HELPPROC$ = "FHelpDlgProc"          ''Help dialog procedure

    SetBitmap CUIDLL$, LOGO
    SetTitle "Luckman Interactive - WWW Yellow Pages"

    '' maximize the window
    hwndSetup% = HwndFrame()
    nRet% = ShowWindow (hwndSetup%, SW_SHOWMAXIMIZED)

    '' put the gauge in the lower right corner
    SetCopyGaugePosition 160, 170

    szInf$ = GetSymbolValue("STF_SRCINFPATH")
    IF szInf$ = "" THEN
	szInf$ = GetSymbolValue("STF_CWDDIR") + "YP.INF"
    END IF
    ReadInfFile szInf$

WELCOME:
    sz$ = UIStartDlg(CUIDLL$, WELCOME, "FInfoDlgProc", APPHELP, HELPPROC$)
    IF sz$ = "CONTINUE" THEN
	UIPop 1
    ELSE
	GOSUB ASKQUIT
	GOTO WELCOME
    END IF


    '' Set destination from SMOSAIC.INI or WMOSAIC.INI
    '' [Installation]
    '' MosaicPath=<path>
    SystemIniPath$ = GetWindowsDir()
    BoolAddIcon% = 0
''    MosaicIniPath$ = SystemIniPath$ + "SMOSAIC.INI"
    MosaicIniPath$ = SystemIniPath$ + "LUCKMAN.INI"
''    IF DoesFileExist( MosaicIniPath$, femExists ) THEN
    IF DoesIniKeyExist( MosaicIniPath$, "Installation", "MosaicPath" ) THEN
    	DEST$ = GetIniKeyString( MosaicIniPath$, "Installation", "MosaicPath" )
	BoolAddIcon% = 1
	'' skip question
	GOTO YPINSTALL
    END IF

    DEST$ = "C:\WIN32APP\NETCMDR\SMOSAIC"

GETPATH:
    SetSymbolValue "EditTextIn", DEST$
    SetSymbolValue "EditFocus", "END"
GETPATHL1:
    sz$ = UIStartDlg(CUIDLL$, DESTPATH, "FEditDlgProc", APPHELP, HELPPROC$)
    DEST$ = GetSymbolValue("EditTextOut")

    IF sz$ = "CONTINUE" THEN
	IF IsDirWritable(DEST$) = 0 THEN
	    GOSUB BADPATH
	    GOTO GETPATHL1
	END IF
	UIPop 1
    ELSEIF sz$ = "REACTIVATE" THEN
	GOTO GETPATHL1
    ELSEIF sz$ = "BACK" THEN
	UIPop 1
	GOTO WELCOME
    ELSE
	GOSUB ASKQUIT
	GOTO GETPATH
    END IF

YPINSTALL:

    ClearBillboardList
    AddToBillboardList CUIDLL$,BILL1,"FModelessDlgProc", 5
    AddToBillboardList CUIDLL$,BILL2,"FModelessDlgProc", 5
    AddToBillboardList CUIDLL$,BILL3,"FModelessDlgProc", 5

    Install

    IF BoolAddIcon% = 1 THEN
    	'' DEST$ has destination of YP
	    ExplorerPath$ = GetIniKeyString( MosaicIniPath$, "Installation", "ExplPath" )
		IF ExplorerPath$ <> "" THEN
		  MosaicExe$ = ExplorerPath$
		ELSE
    	  MosaicExe$ = GetIniKeyString( MosaicIniPath$, "Installation", "MosaicPath" ) + "SMOSAIC.EXE"
	    END IF

	szTemp$ = DEST$ + "yp/yp.ico,,,," + DEST$
''	szTemp2$ = " file:///C|/WIN32APP/NETCMDR/SMOSAIC/YP/SUBJECTS.HTM"
''	CreateProgmanItem "Super Mosaic", "WWW Yellow Pages", MosaicExe$ + szTemp2$, szTemp$, cmoOverwrite

''  changed command line invocation to get users path of YP
	DESTMP1$ = "file:///"  + MID$(DEST$,1,1)
	DESTMP2$ = DESTMP1 + "|"
	LENTMP%  = LEN(DEST$) - 2
	
	DESTMP3$ = MID$(DEST$,3, LENTMP%) + "YP/SUBJECTS.HTM"  
	DESTYP$ = DESTMP2$ + DESTMP3$
	
	LENTMP%  = LEN(DESTYP$)
	
	FINDEST$ = ""
	FOR J%=1 TO LENTMP%
	 IF MID$(DESTYP$,J%, 1) = "\" THEN
	    FINDEST$ = FINDEST$ + "/"
	 ELSE  	 
	    FINDEST$ = FINDEST$ + MID$(DESTYP$,J%, 1)
	 END IF
	
	NEXT J%

	CreateIniKeyValue DEST$ + "SMOSAIC.INI", "Custom_URL_Menu", "url_1", FINDEST$, cmoOverwrite
	
''	CreateProgmanItem "Super Mosaic", "WWW Yellow Pages", MosaicExe$ + " " + FINDEST$, szTemp$, cmoOverwrite
	CreateProgmanItem "Net Commander", "WWW Yellow Pages", MosaicExe$ + " " + FINDEST$, szTemp$, cmoOverwrite

    END IF

QUIT:
    ON ERROR GOTO ERRQUIT

    IF ERR = 0 THEN
	dlg% = EXITSUCCESS
    ELSEIF ERR = STFQUIT THEN
	dlg% = EXITQUIT
    ELSE
	dlg% = EXITFAILURE
    END IF
QUITL1:
    sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
	GOTO QUITL1
    END IF
    UIPop 1

    END

ERRQUIT:
    i% = DoMsgBox("Setup sources were corrupted, contact Luckman Interactive!", "Setup Message", MB_OK+MB_TASKMODAL+MB_ICONHAND)
    END



BADPATH:
    sz$ = UIStartDlg(CUIDLL$, BADPATH, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
	GOTO BADPATH
    END IF
    UIPop 1
    RETURN



ASKQUIT:
    sz$ = UIStartDlg(CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")

    IF sz$ = "EXIT" THEN
	UIPopAll
	ERROR STFQUIT
    ELSEIF sz$ = "REACTIVATE" THEN
	GOTO ASKQUIT
    ELSE
	UIPop 1
    END IF
    RETURN



'**
'** Purpose:
'**     Builds the copy list and performs all installation operations.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB Install STATIC

    SrcDir$ = GetSymbolValue("STF_SRCDIR")
    CreateDir DEST$, cmoNone

    OpenLogFile MakePath(DEST$, "LOGFILE.OUT"), 0
    WriteToLogFile ""
    WriteToLogFile "  User chose as destination directory: '" + DEST$ + "'"
    WriteToLogFile ""
    WriteToLogFile "May have had to create the directory: " + DEST$
    WriteToLogFile ""

    DESTHTM$ = MakePath(DEST$, "YP")
    CreateDir DESTHTM$, cmoNone
    AddSectionFilesToCopyList "htm", SrcDir$, DESTHTM$

    DESTGIF$ = MakePath(DEST$, "YP\GIFS")
    CreateDir DESTGIF$, cmoNone
    AddSectionFilesToCopyList "gif", SrcDir$, DESTGIF$

    CopyFilesInCopyList
    WriteToLogFile "Copied Yellow Pages Files"

    '' Update SMOSAIC.INI (remove the / at the end)
    SystemIniPath$ = GetWindowsDir()
    IF DoesFileExist( SystemIniPath$ + "SMOSAIC.INI", femExists ) THEN
	CreateIniKeyValue SystemIniPath$ + "SMOSAIC.INI", "Installation", "YPPath", DESTHTM$, cmoOverwrite
	CreateIniKeyValue SystemIniPath$ + "SMOSAIC.INI", "Installation", "YPVersion", "1.0", cmoOverwrite
    END IF

    CloseLogFile

END SUB



'**
'** Purpose:
'**     Appends a file name to the end of a directory path,
'**     inserting a backslash character as needed.
'** Arguments:
'**     szDir$  - full directory path (with optional ending "\")
'**     szFile$ - filename to append to directory
'** Returns:
'**     Resulting fully qualified path name.
'*************************************************************************
FUNCTION MakePath (szDir$, szFile$) STATIC AS STRING
    IF szDir$ = "" THEN
	MakePath = szFile$
    ELSEIF szFile$ = "" THEN
	MakePath = szDir$
    ELSEIF MID$(szDir$, LEN(szDir$), 1) = "\" THEN
	MakePath = szDir$ + szFile$
    ELSE
	MakePath = szDir$ + "\" + szFile$
    END IF
END FUNCTION


